#ifndef POSIX_STREAM_H
#define POSIX_STREAM_H

#include <sys/types.h>
#include <streambuf>
#include <string>

// Customized implementation of Josuttis p673-681.
// It is too brittle to be reusable as is.

class PosixBuf : public std::streambuf {
	const int fd_;
	char outbuffer_[4096];
	static const int in_back = 4;
	char inbuffer_[4096 + in_back];
public:
	PosixBuf(const std::string & file_name, int open_flags, int mode = 0);
	virtual ~PosixBuf();
	int FD() const { return fd_; }
	int Lock(short type) const;
	int Truncate(off_t len = 0) const;
private:
	int_type FlushBuffer();
	virtual int_type overflow(int_type c = traits_type::eof());
	virtual int_type underflow();
	virtual int sync();
	virtual pos_type seekpos(pos_type, std::ios_base::openmode = std::ios_base::in | std::ios_base::out);
};


#endif
